package com.ruoyi.cai.mq.config;

import org.springframework.amqp.core.*;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.HashMap;


@Configuration
public class RoomCheckDelayMqConfig {

    public static final String EXCHANGE_NAME = "roomCheckDelayExchange";
    public static final String QUEUE_NAME = "roomCheckDelayQueue";
    public static final String ROUTING_KEY = "roomCheckDelayRouting";

    @Bean
    public CustomExchange roomCheckDelayedExchange() {
        HashMap<String,Object> args = new HashMap<>();
        args.put("x-delayed-type", "direct");
        return new CustomExchange(EXCHANGE_NAME,
                "x-delayed-message", // 消息类型
                true, // 是否持久化
                false,// 是否自动删除
                args);
    }

    @Bean
    public Queue roomCheckDelayedQueue() {
        return QueueBuilder.durable(QUEUE_NAME)
                .withArgument("x-delayed-type", "direct")
                .build();
    }

    @Bean
    public Binding roomCheckDelayedBinding(Queue roomCheckDelayedQueue,CustomExchange roomCheckDelayedExchange) {
        return BindingBuilder.bind(roomCheckDelayedQueue).to(roomCheckDelayedExchange).with(ROUTING_KEY).noargs();
    }

}
